// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/definition"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/term"
)

// DefinitionCreate is the builder for creating a Definition entity.
type DefinitionCreate struct {
	config
	mutation *DefinitionMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetCreatedAt sets the "created_at" field.
func (dc *DefinitionCreate) SetCreatedAt(t time.Time) *DefinitionCreate {
	dc.mutation.SetCreatedAt(t)
	return dc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (dc *DefinitionCreate) SetNillableCreatedAt(t *time.Time) *DefinitionCreate {
	if t != nil {
		dc.SetCreatedAt(*t)
	}
	return dc
}

// SetUpdatedAt sets the "updated_at" field.
func (dc *DefinitionCreate) SetUpdatedAt(t time.Time) *DefinitionCreate {
	dc.mutation.SetUpdatedAt(t)
	return dc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (dc *DefinitionCreate) SetNillableUpdatedAt(t *time.Time) *DefinitionCreate {
	if t != nil {
		dc.SetUpdatedAt(*t)
	}
	return dc
}

// SetText sets the "text" field.
func (dc *DefinitionCreate) SetText(s string) *DefinitionCreate {
	dc.mutation.SetText(s)
	return dc
}

// SetTermID sets the "term" edge to the Term entity by ID.
func (dc *DefinitionCreate) SetTermID(id int) *DefinitionCreate {
	dc.mutation.SetTermID(id)
	return dc
}

// SetNillableTermID sets the "term" edge to the Term entity by ID if the given value is not nil.
func (dc *DefinitionCreate) SetNillableTermID(id *int) *DefinitionCreate {
	if id != nil {
		dc = dc.SetTermID(*id)
	}
	return dc
}

// SetTerm sets the "term" edge to the Term entity.
func (dc *DefinitionCreate) SetTerm(t *Term) *DefinitionCreate {
	return dc.SetTermID(t.ID)
}

// Mutation returns the DefinitionMutation object of the builder.
func (dc *DefinitionCreate) Mutation() *DefinitionMutation {
	return dc.mutation
}

// Save creates the Definition in the database.
func (dc *DefinitionCreate) Save(ctx context.Context) (*Definition, error) {
	dc.defaults()
	return withHooks(ctx, dc.sqlSave, dc.mutation, dc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (dc *DefinitionCreate) SaveX(ctx context.Context) *Definition {
	v, err := dc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (dc *DefinitionCreate) Exec(ctx context.Context) error {
	_, err := dc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (dc *DefinitionCreate) ExecX(ctx context.Context) {
	if err := dc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (dc *DefinitionCreate) defaults() {
	if _, ok := dc.mutation.CreatedAt(); !ok {
		v := definition.DefaultCreatedAt()
		dc.mutation.SetCreatedAt(v)
	}
	if _, ok := dc.mutation.UpdatedAt(); !ok {
		v := definition.DefaultUpdatedAt()
		dc.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (dc *DefinitionCreate) check() error {
	if _, ok := dc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Definition.created_at"`)}
	}
	if _, ok := dc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Definition.updated_at"`)}
	}
	if _, ok := dc.mutation.Text(); !ok {
		return &ValidationError{Name: "text", err: errors.New(`ent: missing required field "Definition.text"`)}
	}
	if v, ok := dc.mutation.Text(); ok {
		if err := definition.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Definition.text": %w`, err)}
		}
	}
	return nil
}

func (dc *DefinitionCreate) sqlSave(ctx context.Context) (*Definition, error) {
	if err := dc.check(); err != nil {
		return nil, err
	}
	_node, _spec := dc.createSpec()
	if err := sqlgraph.CreateNode(ctx, dc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	dc.mutation.id = &_node.ID
	dc.mutation.done = true
	return _node, nil
}

func (dc *DefinitionCreate) createSpec() (*Definition, *sqlgraph.CreateSpec) {
	var (
		_node = &Definition{config: dc.config}
		_spec = sqlgraph.NewCreateSpec(definition.Table, sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt))
	)
	_spec.OnConflict = dc.conflict
	if value, ok := dc.mutation.CreatedAt(); ok {
		_spec.SetField(definition.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := dc.mutation.UpdatedAt(); ok {
		_spec.SetField(definition.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := dc.mutation.Text(); ok {
		_spec.SetField(definition.FieldText, field.TypeString, value)
		_node.Text = value
	}
	if nodes := dc.mutation.TermIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   definition.TermTable,
			Columns: []string{definition.TermColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.term_definitions = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Definition.Create().
//		SetCreatedAt(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.DefinitionUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (dc *DefinitionCreate) OnConflict(opts ...sql.ConflictOption) *DefinitionUpsertOne {
	dc.conflict = opts
	return &DefinitionUpsertOne{
		create: dc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Definition.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (dc *DefinitionCreate) OnConflictColumns(columns ...string) *DefinitionUpsertOne {
	dc.conflict = append(dc.conflict, sql.ConflictColumns(columns...))
	return &DefinitionUpsertOne{
		create: dc,
	}
}

type (
	// DefinitionUpsertOne is the builder for "upsert"-ing
	//  one Definition node.
	DefinitionUpsertOne struct {
		create *DefinitionCreate
	}

	// DefinitionUpsert is the "OnConflict" setter.
	DefinitionUpsert struct {
		*sql.UpdateSet
	}
)

// SetUpdatedAt sets the "updated_at" field.
func (u *DefinitionUpsert) SetUpdatedAt(v time.Time) *DefinitionUpsert {
	u.Set(definition.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *DefinitionUpsert) UpdateUpdatedAt() *DefinitionUpsert {
	u.SetExcluded(definition.FieldUpdatedAt)
	return u
}

// SetText sets the "text" field.
func (u *DefinitionUpsert) SetText(v string) *DefinitionUpsert {
	u.Set(definition.FieldText, v)
	return u
}

// UpdateText sets the "text" field to the value that was provided on create.
func (u *DefinitionUpsert) UpdateText() *DefinitionUpsert {
	u.SetExcluded(definition.FieldText)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create.
// Using this option is equivalent to using:
//
//	client.Definition.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//		).
//		Exec(ctx)
func (u *DefinitionUpsertOne) UpdateNewValues() *DefinitionUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.CreatedAt(); exists {
			s.SetIgnore(definition.FieldCreatedAt)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Definition.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *DefinitionUpsertOne) Ignore() *DefinitionUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *DefinitionUpsertOne) DoNothing() *DefinitionUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the DefinitionCreate.OnConflict
// documentation for more info.
func (u *DefinitionUpsertOne) Update(set func(*DefinitionUpsert)) *DefinitionUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&DefinitionUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *DefinitionUpsertOne) SetUpdatedAt(v time.Time) *DefinitionUpsertOne {
	return u.Update(func(s *DefinitionUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *DefinitionUpsertOne) UpdateUpdatedAt() *DefinitionUpsertOne {
	return u.Update(func(s *DefinitionUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetText sets the "text" field.
func (u *DefinitionUpsertOne) SetText(v string) *DefinitionUpsertOne {
	return u.Update(func(s *DefinitionUpsert) {
		s.SetText(v)
	})
}

// UpdateText sets the "text" field to the value that was provided on create.
func (u *DefinitionUpsertOne) UpdateText() *DefinitionUpsertOne {
	return u.Update(func(s *DefinitionUpsert) {
		s.UpdateText()
	})
}

// Exec executes the query.
func (u *DefinitionUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for DefinitionCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *DefinitionUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *DefinitionUpsertOne) ID(ctx context.Context) (id int, err error) {
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *DefinitionUpsertOne) IDX(ctx context.Context) int {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// DefinitionCreateBulk is the builder for creating many Definition entities in bulk.
type DefinitionCreateBulk struct {
	config
	builders []*DefinitionCreate
	conflict []sql.ConflictOption
}

// Save creates the Definition entities in the database.
func (dcb *DefinitionCreateBulk) Save(ctx context.Context) ([]*Definition, error) {
	specs := make([]*sqlgraph.CreateSpec, len(dcb.builders))
	nodes := make([]*Definition, len(dcb.builders))
	mutators := make([]Mutator, len(dcb.builders))
	for i := range dcb.builders {
		func(i int, root context.Context) {
			builder := dcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*DefinitionMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, dcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = dcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, dcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, dcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (dcb *DefinitionCreateBulk) SaveX(ctx context.Context) []*Definition {
	v, err := dcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (dcb *DefinitionCreateBulk) Exec(ctx context.Context) error {
	_, err := dcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (dcb *DefinitionCreateBulk) ExecX(ctx context.Context) {
	if err := dcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Definition.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.DefinitionUpsert) {
//			SetCreatedAt(v+v).
//		}).
//		Exec(ctx)
func (dcb *DefinitionCreateBulk) OnConflict(opts ...sql.ConflictOption) *DefinitionUpsertBulk {
	dcb.conflict = opts
	return &DefinitionUpsertBulk{
		create: dcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Definition.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (dcb *DefinitionCreateBulk) OnConflictColumns(columns ...string) *DefinitionUpsertBulk {
	dcb.conflict = append(dcb.conflict, sql.ConflictColumns(columns...))
	return &DefinitionUpsertBulk{
		create: dcb,
	}
}

// DefinitionUpsertBulk is the builder for "upsert"-ing
// a bulk of Definition nodes.
type DefinitionUpsertBulk struct {
	create *DefinitionCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.Definition.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//		).
//		Exec(ctx)
func (u *DefinitionUpsertBulk) UpdateNewValues() *DefinitionUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.CreatedAt(); exists {
				s.SetIgnore(definition.FieldCreatedAt)
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Definition.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *DefinitionUpsertBulk) Ignore() *DefinitionUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *DefinitionUpsertBulk) DoNothing() *DefinitionUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the DefinitionCreateBulk.OnConflict
// documentation for more info.
func (u *DefinitionUpsertBulk) Update(set func(*DefinitionUpsert)) *DefinitionUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&DefinitionUpsert{UpdateSet: update})
	}))
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *DefinitionUpsertBulk) SetUpdatedAt(v time.Time) *DefinitionUpsertBulk {
	return u.Update(func(s *DefinitionUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *DefinitionUpsertBulk) UpdateUpdatedAt() *DefinitionUpsertBulk {
	return u.Update(func(s *DefinitionUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetText sets the "text" field.
func (u *DefinitionUpsertBulk) SetText(v string) *DefinitionUpsertBulk {
	return u.Update(func(s *DefinitionUpsert) {
		s.SetText(v)
	})
}

// UpdateText sets the "text" field to the value that was provided on create.
func (u *DefinitionUpsertBulk) UpdateText() *DefinitionUpsertBulk {
	return u.Update(func(s *DefinitionUpsert) {
		s.UpdateText()
	})
}

// Exec executes the query.
func (u *DefinitionUpsertBulk) Exec(ctx context.Context) error {
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the DefinitionCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for DefinitionCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *DefinitionUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
